// © Copyright Mocoolka Corporation 2015,2017.
// Node module: mocoolka-tools
// LICENSE: MIT

/** @module mocoolka-tools */
let fileTools = require('./lib/file-tools.js');
let arrayTools = require('./lib/array-tools.js');
let formatTools = require('./lib/format-tools.js');
let osTools = require('./lib/os-tools.js');
let envTools = require('./lib/env-tools.js');
let moduleTools = require('./lib/module-tools.js');
let globalTools = require('./lib/global-tools.js');
let objectTools = require('./lib/object-tools.js');
let stringTools = require('./lib/string-tools.js');
let errorTools = require('./lib/error-tools.js');
let validTools = require('./lib/validation-tools.js');
let typeTools = require('./lib/type-tools.js');
let jsTools = require('./lib/file/js-tools.js');
let jsonTools = require('./lib/file/json-tools.js');
let ymlTools = require('./lib/file/yml-tools.js');
let transformTools = require('./lib/transform-tools.js');
let unitConvertTools = require('./lib/unit-convert.js');
let watchFileTools = require('./lib/watch-file.js');
let timerTools = require('./lib/timer-tools.js');
let validationTools = require('./lib/validation-tools.js');
let iteratorTools = require('./lib/iterator-tools');
let serviceTools = require('./lib/service-tools');
let TaskEmitter = require('./lib/task/task-emitter');
let markdownTools = require('./lib/markdownTools');

/**
 * init mocoolka-tools
 * @param {string} root - root path
 * @param {string} [lang] - Language ID.
 *     It tries to use App language OS language, then falls back to 'en'
 */
/*let init = (root, language)=> {
  fileTools.init(root);
  i18nTools.init(root, language);

};*/

/*let errorHandler = () =>{
   logger.logError(err).then(sendMailToAdminIfCritical).then(saveInOpsQueueIfCritical).then(determineIfOperationalError);
  //deciding whether to crash when an uncaught exception arrives
//Assuming developers mark known operational errors with error.isOperational=true, read best practice #3
  process.on('uncaughtException', function(error) {
    errorManagement.handler.handleError(error);
    if(!errorManagement.handler.isTrustedError(error))
      process.exit(1)
  });

  process.on('unhandledRejection', function (reason, p) {
    //I just caught an unhandled promise rejection, since we already have fallback handler for unhandled errors (see below), let throw and let him handle that
    throw reason;
  });
  process.on('uncaughtException', function (error) {
    //I just received an error that was never handled, time to handle it and then decide whether a restart is needed
    errorManagement.handler.handleError(error);
    if (!errorManagement.handler.isTrustedError(error))
      process.exit(1);
  });
}*/
let index = {
  jsTools,
  jsonTools,
  ymlTools,
  fileTools,
  arrayTools,
  formatTools,
  osTools,
  envTools,
  moduleTools,
  globalTools,
  objectTools,
  stringTools,
  errorTools,
  validTools,
  typeTools,
  transformTools,
  unitConvertTools,
  watchFileTools,
  timerTools,
  validationTools,
  iteratorTools,
  serviceTools,
  TaskEmitter,
  markdownTools,
};

module.exports.__proto__ = index;

