// © Copyright Mocoolka Corporation 2015,2017.
// Node module: mocoolka-tools
// LICENSE: MIT
/*!
 * Module dependencies.
 */
const  errorTools  = require('./error-tools.js');
class MarkdownTools{
  /**
   * convert section to markdown
   * @param section
   * @property {string}title -section title
   * @property {number}depth -section depth
   * @return {string}
   */
  static sectionToMarkdown (section) {
    errorTools.validateJsonSchema
    ({ schema: schemas.section, data: section });
    let md = '';
    let n = section.depth;

    for (let i = 0; i < n; i++) {
      md += '#';
    };

    md += ' ' + section.title;
    return md;
  };
}
const schemas = {

    section: {
      properties: {
        depth: {
          type: 'number',
        },
        title: {
          type: 'string',
        },
      },
      required: ['depth', 'title'],
    },

  };
/*!
 * Expose `Docs`.
 */

module.exports = MarkdownTools;

